:- include( 'processes' ).
:- include( 'muc' ).

processdef( lamp, [nolight] * ( [on=false, lamp] + [on=true, lampon] ) ).
processdef( lampon, [light] * ( [on=true, lampon] + [on=false, lamp] ) ).

processdef( switch, [swoff] * ( [update(button), s:=true, switchon] +
    [toggle==true, switchtoggle] ) ).
processdef( switchon, [swon] * ( [update(button), s:=false, switch] +
    [toggle==true, switchtoggle] ) ).
processdef( switchtoggle, [update(button), send(s), switchtoggle] +
    [toggle==false, switch] ).

processdef( togglectr, [lamp:=false, [update(sw0), togglectron] +
    [update(sw1), togglectron] + [update(sw2), togglectron]] ).
processdef( togglectron, [lamp:=true, [update(sw0), togglectr] +
    [update(sw1), togglectr] + [update(sw2), togglectr]] ).

processdef( mainctr, [update(sw1), mainctr] + [update(sw2), mainctr] +
    [sw0=true, mainctr_on1] ).
processdef( mainctr_on1, [lamp:=true, [update(sw1),mainctr_on0] +
    [update(sw2),mainctr_on0] + [sw0=false, lamp:=false, mainctr] ] ).
processdef( mainctr_on0, [lamp:=false, [update(sw1),mainctr_on1] +
    [update(sw2),mainctr_on1] + [sw0=false, mainctr]] ).

net( lt, [main:switch, s1:switch, s2:switch, ctr:togglectr, l:lamp],
     [main^s/ctr^sw0, s1^s/ctr^sw1, s2^s/ctr^sw2, ctr^lamp/l^on], 
     [s1^toggle==true, s2^toggle==true] ).

net( lm, [main:switch, s1:switch, s2:switch, ctr:mainctr, l:lamp],
     [main^s/ctr^sw0, s1^s/ctr^sw1, s2^s/ctr^sw2, ctr^lamp/l^on], 
     [s1^toggle==true, s2^toggle==true] ).

net( lmf, [main:switch, s1:switch, s2:switch, ctr:mainctr, l:lamp],
     [main^s/ctr^sw0, s1^s/ctr^sw1, s2^s/ctr^sw2, ctr^lamp/l^on], 
     [main^toggle=true, s1^toggle==true, s2^toggle==true] ).

checkm(R) :-
    failure( ag( ifthen(main^swoff,nolight\/h(l^on=false,1) ) ), lm, R).
