:- include( 'processes' ).
:- include( 'muc' ).

processdef( lamp, [on=false, lamp] + [on=true, lampon] ).
processdef( lampon, [on=true, lampon] + [on=false, lamp] ).

processdef( sensor, [send(temp), tick(2), sensor] ).

processdef( slowctr, [update(temp), tick, [tick, screact] + screact] ).
processdef( screact, [alarm := true, slowctr] + 
                     [alarm := false, slowctr] ).

processdef( fastctr, [update(temp), tick,
    [alarm:=true,fastctr]+[alarm:=false,fastctr]] ).

net( tcslow, [s:sensor, c:slowctr, l:lamp],
     [s^temp/c^temp, c^alarm/l^on], [] ).

net( tcfast, [s:sensor, c:fastctr, l:lamp],
     [s^temp/c^temp, c^alarm/l^on], [] ).

checks( Run ) :-
    failure( all([send(s^temp)], h([l^on=true,l^on=false], 2) ), tcslow, Run ).

checkf( Run ) :-
    failure( all([send(s^temp)], h([l^on=true,l^on=false], 2) ), tcfast, Run ).

checkfa( Run ) :-
    failure( ag( all([send(s^temp)], h([l^on=true,l^on=false], 2) ) ), tcfast, Run ).
